
#include "fbgfx.bi"
Using FB

#include "customfont.bi"

' We declare 3 font arrays since we are going to load
' 3 fonts.
DIM SHARED Font1 AS FontType
DIM SHARED Font2 AS FontType
DIM SHARED Font3 AS FontType

' Sets a graphic mode and 8bit color depth.
SCREEN 13,8,2,0

' This loads FONT 1, 2 and 3 and places each one in
' another array. The last parameter sets the
' width mode. 1 means relative width(each character
' features it's own width) while 2 means unique
' width (all characters feature a single preset 
' width and this is to be used with fonts that 
' are designed and inputted in the font grid on 
' a specific way(FONT 2, FONT 51 and FONT 52).
LoadFont "Fonts/FNT1PAL2.bmp", Font1, 1
LoadFont "Fonts/FNT2PAL2.bmp", Font2, 2
LoadFont "Fonts/FNT3PAL2.bmp", Font3, 1

' A simple loop that ends when the user pushes the
' ESCAPE key.
DO
    
CLS

' Font printing calls. First 2 parameters are the
' string's starting coordinates. Second last parameter
' sets the spacing while the last parameter sets the mode
' of printing (1 - TRANS; 2 - PSET). If you input any
' other number as the last parameter the characters
' will be printed with TRANS.
PrintFont 40,20, "A simple font printing demo", Font1, 1, 1
PrintFont 40,60, "FONT 1 - SPACING 1", Font1, 1, 1
PrintFont 40,80, "FONT 2 - SPACING 0(UNIQUE WIDTH)", Font2, 0, 1
PrintFont 40,100, "FONT 3 - SPACING 3", Font3, 3, 1
PrintFont 40,120, "Some symbol testing: 5+7=2*6", Font2, 0, 1
PrintFont 40,140, "More symbol testing: 12/6=1+1", Font3, 1, 1
PrintFont 40,180, "Press ESC to exit", Font1, 1, 1


' Both LoadFont and LoadBFont subs set the page 1 as the working 
' page and page 0 as the visible page before loading the font 
' so I need to use SCREENCOPY to display the text in this demo. 
SCREENCOPY
SLEEP 2

LOOP UNTIL MULTIKEY(SC_ESCAPE)

END
